xine-lib: xine-lib-1.2.13/src/demuxers/demux_vqa.c File Reference

xine-lib 1.2.13-20230125hg15249

Data Structures | Macros | Functions
demux_vqa.c File Reference
`#include <stdio.h>`
`#include <fcntl.h>`
`#include <unistd.h>`
`#include <string.h>`
`#include <stdlib.h>`
`#include <xine/xine_internal.h>`
`#include <xine/xineutils.h>`
`#include <xine/compat.h>`
`#include <xine/demux.h>`
`#include "bswap.h"`
`#include "group_games.h"`

## Data Structures
struct | demux_vqa_t

## Macros
#define | FOURCC_TAG BE_FOURCC
#define | FORM_TAG FOURCC_TAG('F', 'O', 'R', 'M')
#define | WVQA_TAG FOURCC_TAG('W', 'V', 'Q', 'A')
#define | VQHD_TAG FOURCC_TAG('V', 'Q', 'H', 'D')
#define | FINF_TAG FOURCC_TAG('F', 'I', 'N', 'F')
#define | SND0_TAG FOURCC_TAG('S', 'N', 'D', '0')
#define | SND2_TAG FOURCC_TAG('S', 'N', 'D', '2')
#define | VQFR_TAG FOURCC_TAG('V', 'Q', 'F', 'R')
#define | VQA_HEADER_SIZE 0x2A
#define | VQA_FRAMERATE 15
#define | VQA_PTS_INC (90000 / VQA_FRAMERATE)
#define | VQA_PREAMBLE_SIZE 8

## Functions
static int | probe_vqa_file (input_plugin_t *input)
static int | open_vqa_file (demux_vqa_t *this)
static int | demux_vqa_send_chunk (demux_plugin_t *this_gen)
static void | demux_vqa_send_headers (demux_plugin_t *this_gen)
static int | demux_vqa_seek (demux_plugin_t *this_gen, off_t start_pos, int start_time, int playing)
static int | demux_vqa_get_status (demux_plugin_t *this_gen)
static int | demux_vqa_get_stream_length (demux_plugin_t *this_gen)
static uint32_t | demux_vqa_get_capabilities (demux_plugin_t *this_gen)
static int | demux_vqa_get_optional_data (demux_plugin_t *this_gen, void *data, int data_type)
static demux_plugin_t * | open_plugin (demux_class_t *class_gen, xine_stream_t *stream, input_plugin_t *input)
void * | demux_vqa_init_plugin (xine_t *xine, const void *data)

## Macro Definition Documentation

## ◆ FINF_TAG

#define FINF_TAG FOURCC_TAG('F', 'I', 'N', 'F')

## ◆ FORM_TAG

#define FORM_TAG FOURCC_TAG('F', 'O', 'R', 'M')

## ◆ FOURCC_TAG

#define FOURCC_TAG BE_FOURCC

## ◆ SND0_TAG

#define SND0_TAG FOURCC_TAG('S', 'N', 'D', '0')

## ◆ SND2_TAG

#define SND2_TAG FOURCC_TAG('S', 'N', 'D', '2')

## ◆ VQA_FRAMERATE

#define VQA_FRAMERATE 15

## ◆ VQA_HEADER_SIZE

#define VQA_HEADER_SIZE 0x2A

Referenced by demux_vqa_send_headers(), and open_vqa_file().

## ◆ VQA_PREAMBLE_SIZE

#define VQA_PREAMBLE_SIZE 8

Referenced by demux_vqa_send_chunk(), and open_vqa_file().

## ◆ VQA_PTS_INC

#define VQA_PTS_INC (90000 / VQA_FRAMERATE)

Referenced by demux_vqa_send_chunk(), and demux_vqa_send_headers().

## ◆ VQFR_TAG

#define VQFR_TAG FOURCC_TAG('V', 'Q', 'F', 'R')

## ◆ VQHD_TAG

#define VQHD_TAG FOURCC_TAG('V', 'Q', 'H', 'D')

## ◆ WVQA_TAG

#define WVQA_TAG FOURCC_TAG('W', 'V', 'Q', 'A')

## Function Documentation

## ◆ demux_vqa_get_capabilities()

static uint32_t demux_vqa_get_capabilities | ( | demux_plugin_t * | this_gen | ) |
| static

References DEMUX_CAP_NOCAP.

Referenced by open_plugin().

## ◆ demux_vqa_get_optional_data()

static int demux_vqa_get_optional_data | ( | demux_plugin_t * | this_gen,
|  | void * | data,
|  | int | data_type )
| static

References DEMUX_OPTIONAL_UNSUPPORTED.

Referenced by open_plugin().

## ◆ demux_vqa_get_status()

static int demux_vqa_get_status | ( | demux_plugin_t * | this_gen | ) |
| static

Referenced by open_plugin().

## ◆ demux_vqa_get_stream_length()

static int demux_vqa_get_stream_length | ( | demux_plugin_t * | this_gen | ) |
| static

Referenced by open_plugin().

## ◆ demux_vqa_init_plugin()

void * demux_vqa_init_plugin | ( | xine_t * | xine,
|  | const void * | data )

References demux_plugin_s::dispose, N_, NULL, demux_class_s::open_plugin, and open_plugin().

## ◆ demux_vqa_seek()

static int demux_vqa_seek | ( | demux_plugin_t * | this_gen,
|  | off_t | start_pos,
|  | int | start_time,
|  | int | playing )
| static

References DEMUX_OK.

Referenced by open_plugin().

## ◆ demux_vqa_send_chunk()

static int demux_vqa_send_chunk | ( | demux_plugin_t * | this_gen | ) |
| static

References _X_BE_32, BUF_AUDIO_VQA_IMA, BUF_FLAG_FRAME_END, BUF_VIDEO_VQA, buf_element_s::content, buf_element_s::decoder_flags, DEMUX_FINISHED, buf_element_s::extra_info, buf_element_s::free_buffer, input(), extra_info_s::input_normpos, extra_info_s::input_time, buf_element_s::max_size, NULL, buf_element_s::pts, buf_element_s::size, buf_element_s::type, VQA_PREAMBLE_SIZE, and VQA_PTS_INC.

Referenced by open_plugin().

## ◆ demux_vqa_send_headers()

static void demux_vqa_send_headers | ( | demux_plugin_t * | this_gen | ) |
| static

References _x_demux_control_start(), _x_stream_info_set(), BUF_AUDIO_VQA_IMA, BUF_FLAG_FRAME_END, BUF_FLAG_FRAMERATE, BUF_FLAG_HEADER, BUF_FLAG_STDHEADER, BUF_VIDEO_VQA, buf_element_s::content, buf_element_s::decoder_flags, buf_element_s::decoder_info, DEMUX_OK, buf_element_s::size, buf_element_s::type, VQA_HEADER_SIZE, VQA_PTS_INC, XINE_STREAM_INFO_AUDIO_BITS, XINE_STREAM_INFO_AUDIO_CHANNELS, XINE_STREAM_INFO_AUDIO_SAMPLERATE, XINE_STREAM_INFO_HAS_AUDIO, XINE_STREAM_INFO_HAS_VIDEO, XINE_STREAM_INFO_VIDEO_HEIGHT, and XINE_STREAM_INFO_VIDEO_WIDTH.

Referenced by open_plugin().

## ◆ open_plugin()

static demux_plugin_t * open_plugin | ( | demux_class_t * | class_gen,
|  | xine_stream_t * | stream,
|  | input_plugin_t * | input )
| static

References xine_stream_s::content_detection_method, default_demux_plugin_dispose, DEMUX_FINISHED, demux_vqa_get_capabilities(), demux_vqa_get_optional_data(), demux_vqa_get_status(), demux_vqa_get_stream_length(), demux_vqa_seek(), demux_vqa_send_chunk(), demux_vqa_send_headers(), input(), METHOD_BY_CONTENT, METHOD_BY_MRL, METHOD_EXPLICIT, NULL, open_vqa_file(), probe_vqa_file(), and input_plugin_s::seek.

Referenced by demux_vqa_init_plugin().

## ◆ open_vqa_file()

static int open_vqa_file | ( | demux_vqa_t * | this | ) |
| static

References _X_BE_32, _X_LE_16, input(), VQA_HEADER_SIZE, and VQA_PREAMBLE_SIZE.

Referenced by open_plugin().

## ◆ probe_vqa_file()

static int probe_vqa_file | ( | input_plugin_t * | input | ) |
| static

References _x_demux_read_header(), _x_is_fourcc(), and input().

Referenced by open_plugin().